How to load Tab from a data source in React

You can bind any data object to React Tab items by mapping its fields to the header and content properties.

In the following demo, data is fetched from an OData service using DataManager. The result is formatted as a JSON array of objects with header and content fields, which is set as the items collection of the Tab.

import * as React from "react";
import { useRef, useEffect } from 'react';
import * as ReactDOM from 'react-dom';
import { DataManager, Query, ODataV4Adaptor } from '@syncfusion/ej2-data';
import { TabComponent } from '@syncfusion/ej2-react-navigations';

const SERVICE_URI = 'https://services.odata.org/V4/Northwind/Northwind.svc/Employees';

const App = () => {
  const tabInstance = useRef(null);

  useEffect(() => {
    const fetchTabItems = async () => {
      const e = await new DataManager({ url: SERVICE_URI, adaptor: new ODataV4Adaptor() }).executeQuery(new Query().range(1, 4));
      const result = e.result;
      const mapping = { header: 'FirstName', content: 'Notes' };
      const itemsData = result.map((item) => ({
        header: { text: item[mapping.header] },
        content: item[mapping.content],
      }));
      tabInstance.current.items = itemsData;
      tabInstance.current.refresh();
    };
    if (tabInstance.current) {
      fetchTabItems();
    }
  }, [tabInstance]);

  return (
    <TabComponent heightAdjustMode='Auto' ref={tabInstance}>
    </TabComponent>
  );
}

const root = ReactDOM.createRoot(document.getElementById('element'));
root.render(<App />);
import * as React from "react";
import { useRef, useEffect } from 'react';
import * as ReactDOM from 'react-dom';
import { DataManager, Query, ODataV4Adaptor, ReturnOption } from '@syncfusion/ej2-data';
import { TabComponent } from '@syncfusion/ej2-react-navigations';

const SERVICE_URI: string = 'https://services.odata.org/V4/Northwind/Northwind.svc/Employees';

const App = () => {
  const tabInstance = useRef<TabComponent>(null);

  useEffect(() => {
    const fetchTabItems = async () => {
      const e: ReturnOption = await new DataManager({ url: SERVICE_URI, adaptor: new ODataV4Adaptor() }).executeQuery(new Query().range(1, 4));
      const result: any = e.result;
      const mapping = { header: 'FirstName', content: 'Notes' };
      const itemsData: Object[] = result.map((item: any) => ({
        header: { text: item[mapping.header] },
        content: item[mapping.content],
      }));
      tabInstance.current!.items = itemsData;
      tabInstance.current!.refresh();
    };
    if (tabInstance.current) {
      fetchTabItems();
    }
  }, [tabInstance]);

  return (
    <TabComponent heightAdjustMode='Auto' ref={tabInstance}>
    </TabComponent>
  );
}

const root = ReactDOM.createRoot(document.getElementById('element'));
root.render(<App />);
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React Tab</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="index.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/35.1.37/tailwind3.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
</head>

<body>
    <div id='container'>
        <div id='element'>
                <div id='loader'>Loading</div>
        </div>
    </div>
</body>

</html>

How to load tab with data source in Angular Tab

26 Sep 20264 minutes to read

You can bind any data object to Angular Tab items by mapping the data to the header and content properties.

Dependencies: install the @syncfusion/ej2-data package to use DataManager and adaptors.

You can watch the following video to learn more about loading tab items from a remote data source in the Angular Tabs component:

Steps

  1. Create a DataManager configured with the remote URL and an ODataAdaptor.
  2. Bind the result to the Angular Tab’s items property after the request resolves.
  3. Optionally map remote field names to header.text and content (see Field mapping).

In the following demonstration, data is retrieved from an OData service using Syncfusion’s DataManager; the response is structured as JSON objects with header and content fields, which are then bound to items.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { FormsModule } from '@angular/forms'
import { TabModule } from '@syncfusion/ej2-angular-navigations'




import { Component, OnInit, ViewChild } from '@angular/core';
import { TabComponent } from '@syncfusion/ej2-angular-navigations';
import { DataManager, Query, ODataV4Adaptor, ReturnOption } from '@syncfusion/ej2-data';

const SERVICE_URI: string = 'https://services.odata.org/V4/Northwind/Northwind.svc/Employees';

/**
 * Load tab with DataSource
 */

@Component({
imports: [
         FormsModule, TabModule
    ],


standalone: true,
    selector: 'app-container',
    template: `<ejs-tab #tab></ejs-tab>`
})
export class AppComponent implements OnInit {
    @ViewChild('tab') tabObj?: TabComponent;
    public itemsData: any = [];
    public mapping =  { header: 'FirstName', content: 'Notes' };

    public ngOnInit(): void {
        new DataManager({ url: SERVICE_URI, adaptor: new ODataV4Adaptor})
        .executeQuery(new Query().range(1, 4)).then((e: ReturnOption) => {
            let result: any = e.result;

            for(let i: number = 0; i < result.length; i++) {
                this.itemsData.push({ header: {text: result[i][this.mapping.header]}, content: result[i][this.mapping.content] });
            }
            (this.tabObj as TabComponent).items = this.itemsData;
            (this.tabObj as TabComponent).dataBind();
        });
    }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Field mapping

When the remote payload uses different field names (for example, Title and Body), map them to header.text and content in a transform step before assigning to items.

See Also

How to load tab with DataSource in Vue Tabs

02 Sep 20264 minutes to read

You can bind any data object to Tab items by mapping it to the header and content properties.

To render the Vue Tab component with a data source, you can check out this video:

In the following demo, data is fetched from an OData service using DataManager. The result data is formatted as a JSON object with header and content fields, which is set to the items property of the Tab.

<template>
  <div id="app">
  <ejs-tab ref="TabInstance">

  </ejs-tab>
</div>
</template>
<script setup>

import { TabComponent as EjsTab} from '@syncfusion/ej2-vue-navigations';
import { DataManager, Query, ODataV4Adaptor } from '@syncfusion/ej2-data';
import { onMounted, ref } from 'vue';

const TabInstance=ref(null);
onMounted(() => {  
new DataManager({ url: 'https://services.odata.org/V4/Northwind/Northwind.svc/Employees', adaptor: new ODataV4Adaptor}).executeQuery(new Query().range(4, 7)).then((e) => {

      var result = e.result;
      var obj = TabInstance.value.ej2Instances
      var itemsData =[];
      var  mapping =  { header: 'FirstName', content: 'Notes' };
      for(var i= 0; i < result.length; i++) {
      itemsData.push({ header: {text: result[i][mapping.header]}, content: result[i][mapping.content] });
     }
    obj.items = itemsData;
    obj.refresh();

});
});

</script>

<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-buttons/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-popups/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-navigations/styles/material.css";
</style>
<template>
  <div id="app">
    <ejs-tab ref="TabInstance">

    </ejs-tab>
  </div>
</template>
<script>

import { TabComponent } from '@syncfusion/ej2-vue-navigations';
import { DataManager, Query, ODataV4Adaptor } from '@syncfusion/ej2-data';

export default {
  name: "App",
  components: {
    "ejs-tab": TabComponent
  },
  mounted() {
    new DataManager({ url: 'https://services.odata.org/V4/Northwind/Northwind.svc/Employees', adaptor: new ODataV4Adaptor }).executeQuery(new Query().range(4, 7)).then((e) => {

      var result = e.result;
      var obj = this.$refs.TabInstance.ej2Instances
      var itemsData = [];
      var mapping = { header: 'FirstName', content: 'Notes' };
      for (var i = 0; i < result.length; i++) {
        itemsData.push({ header: { text: result[i][mapping.header] }, content: result[i][mapping.content] });
      }
      obj.items = itemsData;
      obj.refresh();

    });
  }
}
</script>

<style>
@import "../node_modules/@syncfusion/ej2-base/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-buttons/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-popups/styles/material.css";
@import "../node_modules/@syncfusion/ej2-vue-navigations/styles/material.css";
</style>